.bp
.he 'XTERM (xwin)'TROPIX: Manual de Referncia'XTERM (xwin)'
.fo 'Escrito em 18.03.05'Verso 4.8.0'Pag. %'

.b NOME
.in 5
xterm - emulador de terminal ANSI para o X-Window.

.in
.sp
.b SINTAXE
.in 5
xterm [opes] [-e <comando> [<arg>...]]

.in
.sp
.b DESCRIO
.in 5
O cliente "xterm"  uma verso simplificada do emulador de terminal "rxvt",
distribudo como contribuio ao X-Window.
Sua funo  criar, na tela grfica, uma janela de texto para que
um comando qualquer do TROPIX possa ser executado.
Normalmente, esse comando  o interpretador "shell" (veja "sh (cmd)").
.sp

.in 5
As opes disponveis so as seguintes:
.in 8

.ip "-d <display>" 20
indica o servidor X a contactar. O default  o servidor local.

.ip "-D <desktop>" 20
especifica o nmero do "desktop" em que a janela "xterm" ser
criada.

.ip "-b <cor_de_fundo>" 20
modifica a cor de fundo da janela.
O default  branco.
Para maiores detalhes sobre especificaes de cores, veja "X (xwin)".

.ip "-f <cor_de_frente>" 20
modifica a cor do texto da janela.
O default  preto.
Para maiores detalhes sobre especificaes de cores, veja "X (xwin)".

.ip "-c <cor_do_cursor>" 20
modifica a cor do cursor.
O default  preto.
Para maiores detalhes sobre especificaes de cores, veja "X (xwin)".

.ip "-F <fonte>" 20
especifica a fonte a ser utilizada.

.ip "-C" 20
captura as mensagens de erro provenientes do ncleo do sistema.
A janela correspondente ter ttulo "Console (ptyc??)", diferenciando-a
das demais.
Se mais de um comando "xterm" especificar a opo "-C", apenas um deles conseguir
desviar as mensagens.

.ip "-g <geometria>" 20
especifica a geometria da janela, no formato [<lin>x<col>][<x><y>].
Para maiores detalhes sobre especificao de geometria, veja "X (xwin)".

.ip "-h <diretrio>" 20
especifica o diretrio inicial.

.ip "-i" 20
a janela "xterm" inicia na forma "iconificada".

.ip "-t <ttulo>" 20
modifica o ttulo da janela. O default  "xterm (ptyc??)",
onde ptyc?? indica o pseudo-terminal utilizado.
Para maiores detalhes sobre especificao de fontes, veja "X (xwin)".

.ip "-s <linhas>" 20
indica o nmero de linhas que devem ser salvas para posterior
exame atravs da barra de rolamento. O default  64 linhas.
Especificar o valor 0 implica a supresso da barra de rolamento.

.ip "-e <comando> [<arg>...]" 20
executa <comando> na janela criada pelo "xterm". O default 
o interpretador de comandos shell ("/bin/sh").
Esta opo deve obrigatoriamente ser a ltima na chamada,
uma vez que o comando pode receber argumentos.

.ip "-color<n> <cor>" 20
altera o nome da cor bsica <n> para <cor>, onde <n> pode variar
de 0 a 15, significando: 0 - preto, 1 - azul, 2 - verde, 3 - ciano,
4 - vermelho, 5 - magenta, 6 - marrom, 7 - branco sujo, 8 - preto,
9 - azul claro, 10 - verde claro, 11 - ciano claro, 12 - vermelho claro,
13 - magenta claro, 14 - marrom claro, 15 - branco.
.ep

.in
.sp
.b
COMPATIBILIDADE
.in 5
Por questo de compatibilidade com o emulador "xterm" original,
so aceitas opes com nomes longos, a saber:
.sp
.nf
          -bg		equivale a	-b
          -background	equivale a	-b
	  -cr		equivale a	-c
	  -desktop	equivale a	-D
          -display	equivale a	-d
          -fg		equivale a	-f
          -foreground	equivale a	-f
          -fn		equivale a	-F
          -font		equivale a	-F
          -geometry	equivale a	-g
          -title	equivale a	-t
.fi
.sp
As opes longas podem ser includas no arquivo $HOME/.Xdefaults, de
modo que fiquem implcitas a cada execuo do "xterm". Por exemplo,
um arquivo $HOME/.Xdefaults contendo as seguintes linhas
.sp
.nf
          XTerm*background:     black
          XTerm*geometry:       80x44
          XTerm*color4:         orange
.fi
.sp
far com que toda execuo do "xterm" assuma o fundo preto, a geometria
de 44 linhas por 80 colunas e a cor vermelha (4) passe a ser laranja.


.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd):  "
sh
.br
.in 5
.wo "(fmt):  "
terminfo
.br
.in 5
.wo "(xwin): "
X, fvwm
.br

.in
.sp
.b
EXEMPLOS
.r
.ip
xterm -b darkgreen -f white -F 7x13bold
.in 5
.ip
A janela "xterm" ter fundo verde escuro, texto branco e usar
a fonte 7x13bold.
.in -5

.ip
xterm -C -g 80x13+30+100
.in 5
.ip
A janela "xterm" ter 80 colunas e 13 linhas.
Se possvel, o gerenciador de janelas ("fvwm") posicionar o
canto superior esquerdo da janela nas coordenadas (30, 100),
a partir do canto superior esquerdo do "desktop".
Nesta janela sero impressas as mensagens de erro do ncleo do sistema,
se j no houver outra com essa finalidade.
.in -5

.ip
xterm -g 80x30 -t Coremap -e coremap
.in 5
.ip
A janela "xterm" ter 80 colunas, 30 linhas e ttulo "Coremap (ptyc??)".
O comando a ser executado  "coremap", que mostra um
mapa de alocao de memria (veja "coremap (cmd)").
.in -5
.ep

.in
.sp
.b ESTADO
.in 5
Efetivo.
